package com.gic.haoban.manage.api.service;

import com.gic.haoban.manage.api.dto.SyncCheckDTO;
import com.gic.haoban.manage.api.dto.SyncSingleDealDTO;

import java.util.List;

/**
 * Created 2020/4/9.
 *
 * @author hua
 */
public interface DealSyncOperationApiService {

    /**
     * 部门同步处理
     *
     * @param params
     */
    public void departmentDealMq(String params);

    /**
     * 处理前端数据
     *
     * @param addList
     * @param editList
     */
    public void dealDepartment(String taskId, String wxEnterpriseId, List<SyncSingleDealDTO> addList, List<SyncSingleDealDTO> editList);

    /**
     * 重新执行任务
     *
     * @param taskId
     */
    public void reDealDepartment(String taskId, int dataType);

    /**
     * 创建任务
     *
     * @param taskName
     * @param userId
     * @param desc
     */
    public String createTask(String wxEnterpriseId, String taskName, String userId, String desc);

    /**
     * 关闭任务
     *
     * @param wxEnterpriseId
     * @return
     */
    public boolean closeTask(String wxEnterpriseId);


    /**
     * 解锁
     *
     * @param taskId
     */
    public void unlockTask(String taskId);

    /**
     * 校验是否锁
     *
     * @param wxEnterpriseId
     * @return
     */
    public String getTaskLock(String wxEnterpriseId);

    /**
     * 校验同步状态
     *
     * @param wxEnterpriseId
     * @return
     */
    public SyncCheckDTO getTaskCheck(String wxEnterpriseId);


}
