package com.gic.haoban.manage.service.service.impl;

import com.gic.haoban.manage.api.dto.SyncCheckDTO;
import com.gic.haoban.manage.api.enums.PreDealStatusEnum;
import com.gic.haoban.manage.api.enums.PreDealTypeEnum;
import com.gic.haoban.manage.service.dao.mapper.PreDealLogMapper;
import com.gic.haoban.manage.service.entity.TabHaobanPreDealLog;
import com.gic.haoban.manage.service.service.PreDealService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created 2020/4/9.
 *
 * @author hua
 */
@Service
public class PreDealServiceImpl implements PreDealService {

    @Autowired
    private PreDealLogMapper preDealLogMapper;

    @Override
    public boolean insert(List<TabHaobanPreDealLog> list) {
        for (TabHaobanPreDealLog tab : list) {
            preDealLogMapper.insert(tab);
        }
        return true;
    }

    @Override
    public TabHaobanPreDealLog getByDataId(String taskId, String dataId, int status) {
        TabHaobanPreDealLog byDataId = preDealLogMapper.getByDataId(taskId, dataId, status);
        return byDataId;
    }

    @Override
    public List<TabHaobanPreDealLog> listByPDataId(String taskId, String pDataId, int status) {
        return preDealLogMapper.listByPDataId(taskId, pDataId, status, PreDealTypeEnum.group.getVal());
    }

    @Override
    public List<TabHaobanPreDealLog> listReByPDataId(String taskId, String pDataId) {
        return preDealLogMapper.listReByPDataId(taskId, pDataId, PreDealTypeEnum.group.getVal());
    }

    @Override
    public boolean updateStatusByDataId(String taskId, String dataId, int status, String reason) {
        int i = preDealLogMapper.updateStatusByDataId(taskId, dataId, status, reason);
        return i >= 0;
    }

    @Override
    public boolean checkTask(String taskId, int dataType) {
        int i = preDealLogMapper.checkTask(taskId, dataType, PreDealStatusEnum.pre.getVal());
        return i == 0;
    }

    @Override
    public List<TabHaobanPreDealLog> listByTaskId(String taskId, int dataType, int status) {
        return preDealLogMapper.listByTaskId(taskId, dataType, status);
    }

    @Override
    public int countByTaskId(String taskId, int dataType, int status) {
        return preDealLogMapper.countByTaskId(taskId, dataType, status);
    }

    @Override
    public int countExcepAndPreByTaskId(String taskId, int dataType) {
        return preDealLogMapper.countExcepAndPreByTaskId(taskId, dataType);
    }

    @Override
    public List<TabHaobanPreDealLog> queryDepartRebuildDealLog(String taskId) {
        return preDealLogMapper.listRebuildDepartByTaskId(taskId);
    }

    @Override
    public List<TabHaobanPreDealLog> listRebuildByTaskId(String taskId, int dataType) {
        return preDealLogMapper.listRebuildByTaskId(taskId, dataType);
    }
}
